VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Begin VB.Form Form1 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Form1"
   ClientHeight    =   6240
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   11730
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   6240
   ScaleWidth      =   11730
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox Text1 
      Height          =   2295
      Left            =   30
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   6
      Text            =   "Form1.frx":0000
      Top             =   3900
      Width           =   11655
   End
   Begin MSComctlLib.TreeView TreeView1 
      Height          =   3390
      Left            =   2670
      TabIndex        =   4
      Top             =   450
      Width           =   9015
      _ExtentX        =   15901
      _ExtentY        =   5980
      _Version        =   393217
      Indentation     =   529
      LineStyle       =   1
      Style           =   7
      Appearance      =   1
   End
   Begin VB.CheckBox Check1 
      Caption         =   "mit Unterordner"
      Height          =   285
      Left            =   7590
      TabIndex        =   3
      Top             =   90
      Width           =   1395
   End
   Begin VB.DirListBox Dir1 
      Height          =   3015
      Left            =   60
      TabIndex        =   2
      Top             =   810
      Width           =   2565
   End
   Begin VB.DriveListBox Drive1 
      Height          =   315
      Left            =   60
      TabIndex        =   1
      Top             =   450
      Width           =   2565
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Start"
      Height          =   345
      Left            =   9060
      TabIndex        =   0
      Top             =   60
      Width           =   2625
   End
   Begin VB.Label Label1 
      BackColor       =   &H00FFFFFF&
      BorderStyle     =   1  'Fixed Single
      Height          =   285
      Left            =   60
      TabIndex        =   5
      Top             =   90
      Width           =   7455
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' Prinzip:
' 1. Alle Dateien vom ausgewhltem Ordner (optional aller Unterordner) erfassen.
' 2. Erfasste Dateien nach Gre (Aufsteigend) sortieren.
' 3. Alle Dateien, die grer als die angegebene CD-Kapazitt sind, aus dem
'    Array entfernen da groe Dateien ja nicht gesplittet werden drfen.
' 4. CD anlegen und zuerst die groen Dateien hinzufgen. Passt die nchste
'    Datei nicht mehr in die Kapazitt, dann die restliche Kapazitt mit kleinen
'    Dateien auffllen. Ist die Kapazitt erreicht, dann wieder bei Punkt 4 anfangen
'    bis keine Dateien mehr vorhanden sind die verarbeitet werden knnen.

' Kapazitt der CD
Private Const MaxCDSize As Currency = 700 ' Angabe in MB

Private Sub Command1_Click()

    Dim lngItem As Long
    Dim lngMax As Long
    Dim lngMin As Long
    Dim lngCount As Long
    Dim lngFileCount As Long
    Dim lngCdCount As Long
    Dim curCdSize As Currency
    Dim curSize As Currency
    Dim MbDiv As Currency
    Dim xNode As Node
    Dim sngStart As Single
    
    ' fr die Zeitmessung
    sngStart = Timer
    
    ' fr die Umrechnung in Megabyte
    MbDiv = CCur(1024) ^ 2
    
    ' Controls deaktivieren
    Command1.Enabled = False
    TreeView1.Enabled = False
    Dir1.Enabled = False
    Drive1.Enabled = False
    
    ' Array lschen und vordimensionieren
    Erase m_Files
    ReDim m_Files(0)
    
    ' Inhalt vom TreeView lschen
    TreeView1.Nodes.Clear
    
    ' Inhalt von der Textbox lschen
    Text1.Text = vbNullString
    
    ' Info ausgeben
    Me.Caption = "Bitte warten..."
    
    Text1.Text = Text1.Text & "Dateien zum verarbeiten werden erfasst. Bitte " & _
        "warten..." & vbNewLine
        
    DoEvents
    
    ' alle Dateien im angegebenen Pfad ermitteln
    ' Optional auch alle Unterordner erfassen
    lngCount = GetAllFiles(Dir1.Path, "*", m_Files, CBool(Check1.Value))
    
    ' wenn keine Dateien im angegebenen Ordner/Unterordner vorhanden sind
    If lngCount = 0 Then
    
        ' Info ausgeben
        Text1.Text = Text1.Text & "keine Dateien zum verarbeiten. Fertig" & vbNewLine
        
        ' Controls aktivieren
        Command1.Enabled = True
        TreeView1.Enabled = True
        Dir1.Enabled = True
        Drive1.Enabled = True
        
        ' Prozedur verlassen
        Exit Sub
        
    End If
    
    ' Info ausgeben
    Text1.Text = Text1.Text & "insgesamt wurden " & CStr(lngCount) & " Dateien " & _
        "erfasst. Daten werden jetzt nach Gre sortiert. Bitte warten..." & _
        vbNewLine
        
    DoEvents
    
    ' Dateien nach Gre sortieren
    Call QuickSort(0, lngCount - 1)
    
    ' Info ausgeben
    Text1.Text = Text1.Text & "Dateien wurden nach Gre sortiert." & vbNewLine
    
    DoEvents
    
    ' nur Dateien, die kleiner MaxCDSize sind
    For lngItem = lngCount - 1 To 0 Step -1
    
        ' ist die Dateigre <= MaxCDSize
        If m_Files(lngItem).Size / MbDiv <= MaxCDSize Then
        
            ' Schleife verlassen
            Exit For
            
        Else
        
            ' ansonsten Info ausgeben das diese Datei nicht verarbeitet wird
            ' da grer MaxCDSize
            Text1.Text = Text1.Text & m_Files(lngItem).File & " kann nicht " & _
                "verarbeitet werden da grer als " & CStr(MaxCDSize) & " MB" & _
                vbNewLine
                
            DoEvents
            
        End If
        
        ' nchstes Element
    Next lngItem
    
    ' Array erneut redimensionieren
    ' ohne Dateien > MaxCDSize
    ReDim Preserve m_Files(lngItem)
    
    ' Start- und Endwert festlegen
    lngMin = 0
    lngMax = UBound(m_Files)
    
    ' Info ausgeben
    Text1.Text = Text1.Text & "insgesamt knnen " & CStr(lngMax + 1) & " " & _
        "Dateien verarbeitet werden." & vbNewLine
        
    ' erste CD
    lngCdCount = 1
    
    Do
    
        ' Info ausgeben
        Text1.Text = Text1.Text & "CD" & CStr(lngCdCount) & " wird " & _
            "zusammengestellt. Bitte warten..." & vbNewLine
            
        ' CD anlegen
        Set xNode = TreeView1.Nodes.Add(, , "CD" & CStr(lngCdCount), "CD" & CStr( _
            lngCdCount))
            
        ' Node immer im sichtbaren Bereich des TreeView
        xNode.EnsureVisible
        
        DoEvents
        
        ' aktuelle Gre wieder auf 0 setzen
        curCdSize = 0
        
        ' Anzahl der Dateien auf 0 setzen
        lngFileCount = 0
        
        ' alle Elemente von End- bis Startwert durchlaufen
        ' von der grten zur kleinsten Dateigre
        For lngItem = lngMax To lngMin Step -1
        
            ' Dateigre in MB umrechnnen
            curSize = m_Files(lngItem).Size / MbDiv
            
            ' ist die aktuell belegte Gre + Dateigre <= MaxCDSize
            If curCdSize + curSize <= MaxCDSize Then
            
                ' Gre der Datei hinzu addieren
                curCdSize = curCdSize + curSize
                
                ' Anzahl der verarbeiteten Dateien
                lngFileCount = lngFileCount + 1
                
                ' Datei zur CD hinzufgen
                TreeView1.Nodes.Add "CD" & CStr(lngCdCount), tvwChild, , m_Files( _
                    lngItem).File & " [" & CStr(m_Files(lngItem).Size) & " Byte " & _
                    "= " & Format$(curSize, "0.00") & " MB]"
                    
                ' alle 100 Dateien mal ein Doevents einwerfen
                If (lngItem Mod 100) = 0 Then
                
                    ' Text der CD entsprechend anpassen
                    xNode.Text = "CD" & CStr(lngCdCount) & " [" & CStr( _
                        lngFileCount) & " Dateien = " & Format$(curCdSize, _
                        "0.00") & " MB]"
                        
                    DoEvents
                    
                End If
                
            Else
            
                ' Schleife verlassen
                Exit For
                
            End If
            
            ' nchstes Element
        Next lngItem
        
        ' Endwert speichern
        lngMax = lngItem
        
        ' alle Elemente von Start- bis Endwert durchlaufen
        ' von der kleinsten zur grten Dateigre
        For lngItem = lngMin To lngMax
        
            ' Dateigre in MB umrechnnen
            curSize = m_Files(lngItem).Size / MbDiv
            
            ' ist die aktuell belegte Gre + Dateigre <= MaxCDSize
            If curCdSize + curSize <= MaxCDSize Then
            
                ' Gre der Datei hinzu addieren
                curCdSize = curCdSize + curSize
                
                ' Anzahl der verarbeiteten Dateien
                lngFileCount = lngFileCount + 1
                
                ' Datei zur CD hinzufgen
                TreeView1.Nodes.Add "CD" & CStr(lngCdCount), tvwChild, , m_Files( _
                    lngItem).File & " [" & CStr(m_Files(lngItem).Size) & " Byte " & _
                    "= " & Format$(curSize, "0.00") & " MB]"
                    
                ' alle 100 Dateien mal ein Doevents einwerfen
                If (lngItem Mod 100) = 0 Then
                
                    ' Text der CD entsprechend anpassen
                    xNode.Text = "CD" & CStr(lngCdCount) & " [" & CStr( _
                        lngFileCount) & " Dateien = " & Format$(curCdSize, _
                        "0.00") & " MB]"
                        
                    DoEvents
                    
                End If
                
            Else
            
                ' Schleife verlassen
                Exit For
                
            End If
            
            ' nchstes Element
            
        Next lngItem
        
        ' Startwert speichern
        lngMin = lngItem
        
        ' Text der CD entsprechend anpassen
        xNode.Text = "CD" & CStr(lngCdCount) & " [" & CStr(lngFileCount) & " " & _
            "Dateien = " & Format$(curCdSize, "0.00") & " MB]"
            
        ' Anzahl der bentigten CDs erhhen
        lngCdCount = lngCdCount + 1
        
        ' Do/Loop verlassen wenn alle Dateien verarbeitet wurden
        If (lngMax = -1) Or (lngMin - 1 = lngMax) Then
        
            Exit Do
            
        End If
        
        ' solange durchlaufen bis alle Dateien verarbeitet sind
    Loop
    
    ' Info ausgeben
    Me.Caption = "insgesamt werden " & CStr(lngCdCount - 1) & " CD(s) zu je " & _
        CStr(MaxCDSize) & "MB bentigt."
        
    ' Controls aktivieren
    Command1.Enabled = True
    TreeView1.Enabled = True
    Dir1.Enabled = True
    Drive1.Enabled = True
    
    Text1.Text = Text1.Text & "Fertig" & vbNewLine
    
    MsgBox "Fertig in " & Format$((Timer - sngStart)) & " " & _
        "Sekunden", vbOKOnly Or vbInformation, "Verabeitung abgeschlossen"
    
End Sub

Private Sub Dir1_Change()

    ' Pfad im Label anzeigen
    Label1.Caption = Dir1.Path
    
End Sub

Private Sub Drive1_Change()

    ' Pfad fr DirListBox setzen
    Dir1.Path = Drive1.Drive
    
End Sub

Private Sub Form_Load()

    ' Pfad im Label anzeigen
    Label1.Caption = Dir1.Path
    
    ' Inhalt der Textbox lschen
    Text1.Text = vbNullString
    Text1.Locked = True
    
End Sub

Private Sub Text1_Change()

    ' hinzugefgter Text immer im sichtbaren Bereich anzeigen
    Text1.SelStart = Len(Text1.Text)
    
End Sub
